<?php

/*
Plugin Name: GetSimple Gmail Newsletter
Description: Send Newsletter in PHP or SMTP via Gmail
Version: 1.1
Author: Jacques Malgrange
Author URI: http://www.boiteasite.fr
*/
$thisfile = basename(__FILE__, '.php');
register_plugin(
	$thisfile,
	'Gmail Newsletter',
	'1.1',
	'Jacques Malgrange',
	'http://www.boiteasite.fr',
	'Envoie une newsletter &agrave; une liste de mails avec PHP mail() ou Gmail',
	'plugins',
	'gmail_newsletter'
);
//
add_filter('content', 'gmail_newsletter_filter');
add_action('plugins-sidebar', 'createSideMenu', array($thisfile, 'Gmail Newsletter'));
define ('CONFIGFILE', GSDATAOTHERPATH . 'gmail_newsletter.xml');
require(dirname(__FILE__).'/gmail_newsletter/key.php');
//
function gmail_newsletter_filter($contents)
	{
	global $i18n;
	$contents = f_shortcode($contents);
	return $contents;
	}

function gmail_newsletter() 
	{
	global $SITEURL;
	if (isset($_GET['delete'])) 
		{
		$mail = $_GET['delete'];
		f_delete_gmail($mail);
		echo '<script type="text/javascript">window.location.replace("'.$SITEURL.'admin/load.php?id=gmail_newsletter");</script>';
		}
	else if (isset($_GET['add']))
		{
		f_add_gmail();
		echo '<script type="text/javascript">window.location.replace("'.$SITEURL.'admin/load.php?id=gmail_newsletter");</script>';
		}
	else f_gmail();
	}
//
function f_gmail() 
	{   
	$data = f_load_gmail();
	global $SITENAME;
	if (isset($_COOKIE['GS_ADMIN_USERNAME'])) $cook = _id($_COOKIE['GS_ADMIN_USERNAME']);	else $cook = "admin";
	$da = getXML(GSUSERSPATH . $cook . '.xml'); $EMAIL = $da->EMAIL;
	if (isset($data['mails'])) f_gmail_list($data['mails']); else f_gmail_list(null); ?>
	
	<form action="" name="formNews" method="post" accept-charset="utf-8">
		<input name="site" type="hidden" value="<?php echo $SITENAME; ?>" />
		<input name="admail" type="hidden" value="<?php echo $EMAIL; ?>" />
		<hr />
		<h3>Type d'envoi</h3>
		<table><tr><td>
			<label>Envoi SMTP avec votre compte Gmail (plus fiable)</label>
		<input type="checkbox" name="smtp" value="1"<?php if($data['smtp']=='1') echo ' checked'; ?> onchange="if(this.checked)document.getElementById('onGmail').style.visibility='visible';else document.getElementById('onGmail').style.visibility='hidden';" />
		</td><td>
			<div id="onGmail"<?php if($data['smtp']!='1') echo ' style="visibility:hidden;"'; ?>>
				<label>Adresse mail Gmail : </label>
				<input type="text" name="gmail" value="<?php echo $data['gmail']; ?>" />
				<label>Mot de passe Gmail : </label>
				<input type="password" name="pgmail"  value="<?php echo $data['pgmail']; ?>" />
			</div>
		</td></tr></table>
		<hr />
		<h3>Newsletter</h3>
		<p>
			<b>Sujet :</b>
			<input name="mail-subject" size="50" type="text" value="<?php echo $data['subject']; ?>" />
		</p><p>
			<b>Message :</b><br />
			<textarea name="mail-body"><?php echo $data['body']; ?></textarea>
		</p><p>
			<input name="submit" class="submit" value="Envoyer" onclick="f_send();" />
		</p>
	</form>
	<?php
	global $HTMLEDITOR; global $SITEURL;
	if (isset($HTMLEDITOR) && $HTMLEDITOR != '') 
		{
		$TOOLBAR = "['Bold', 'Italic', 'Underline', 'NumberedList', 'BulletedList', 'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock', 'Link', 'Unlink', 'Image', 'RemoveFormat', 'Source']";
		if (defined('GSEDITORLANG')) $EDLANG = GSEDITORLANG; else $EDLANG = i18n_r('CKEDITOR_LANG');
		if (defined('GSEDITOROPTIONS') && trim(GSEDITOROPTIONS)!="") $EDOPTIONS = ", ".GSEDITOROPTIONS; else $EDOPTIONS = '';
		?>
		<script type="text/javascript" src="template/js/ckeditor/ckeditor.js"></script>
		<script type="text/javascript">
		var editor = CKEDITOR.replace('mail-body', {
			skin : 'getsimple',
			forcePasteAsPlainText : true,
			language : '<?php echo $EDLANG; ?>',
			defaultLanguage : '<?php echo $EDLANG; ?>',
			entities : true,
			uiColor : '#ffffff',
			height: '250',
			toolbar :[<?php echo $TOOLBAR; ?>]<?php echo $EDOPTIONS; ?>,                
			tabSpaces:10,
			filebrowserBrowseUrl : 'filebrowser.php?type=all',
			filebrowserImageBrowseUrl : 'filebrowser.php?type=images',
			filebrowserWindowWidth : '730',
			filebrowserWindowHeight : '500'
		});
		function f_send(){
			window.scrollTo(0,0);
			jQuery(document).ready(function(){
				jQuery('#result').empty();jQuery('#result').append("Envoi en cours...<br />");
				a=[<?php $c=0; foreach ($data['mails'] as $r) {echo ($c!=0?',':'').'"'.$r.'"';++$c;} ?>];
				jQuery.each(a,function(k,v){
					h=jQuery('form[name=formNews]').serializeArray();
					h.push({name:'dest',value:v});
					h.push({name:'num',value:k}); // sauvegarde seulement la premiere fois (num=0)
					h.push({name:'body',value:editor.getData()});
					h.push({name:'back',value:'<?php echo $SITEURL; ?>'});
					if(k==0){
						h.push({name:'configfile',value:'<?php echo CONFIGFILE;?>'});
						h.push({name:'mails',value:'<?php echo join(",",$data['mails']); ?>'});
					}
					jQuery.ajax({type:'POST',url:'<?php echo $SITEURL; ?>plugins/gmail_newsletter/ajax_send.php',data:h,async:false}).done(function(r){jQuery('#result').append(r);});
				});
			jQuery('#result').append("<br />...Termin&eacute.");
			});
		}
		</script>
		<?php
		}
	}
//
function f_gmail_list($mails) 
	{ 
	echo '<div id="result"></div>';
	echo '<h3>Liste des destinataires</h3>';

	if (!empty($mails)) 
		{
		$liste="";
		echo '<table class="highlight">';
		foreach ($mails as $mail) 
			{
			$liste.=(($liste!='')?',':'').$mail;
			echo '<tr><td  colspan="2" style="line-height:12px!important;"><a href="" title="Edit mail:'.$mail.'">'.$mail.'</a></td>';
			echo '<td class="delete" style="line-height:12px!important;"><a style="padding:0 6px!important;" href="load.php?id=gmail_newsletter&delete='.$mail.'" title="Delete mail: '.$mail.'?">X</a></td></tr>'; // class="delconfirm"
			}
		echo '<tr><td style="text-align:left;font-size:110%;color:#888;font-weight:700;cursor:pointer;" onClick="javascript:alert(\''.$liste.'\');">R&eacute;cup&eacute;rer la liste</td><td style=text-align:right;font-size:110%;color:#888;font-weight:700;padding-right:10px;">Tout supprimer</td><td class="delete"><a style="padding:0 6px!important;" href="load.php?id=gmail_newsletter&delete=all" title="Delete mail : all ?">X</a></td></tr>';
		echo '</table>';
		}
	echo '<b>'.count($mails).'</b> abonn&eacute;'.((count($mails)>1)?'s':'');
	f_gmail_form();
	} 
//
function f_delete_gmail($mail)
	{
	$new = array();   
	$data = f_load_gmail();
	foreach ($data['mails'] as $current)
		{
		if ($current!=$mail && $mail!="all") $new[] = $current;
		}
	f_save_gmail($new, $data); 
	f_gmail();
	}
//
function f_add_gmail()
	{
	$new = $_POST['new-mail'];  
	$mails = array();
	$data = f_load_gmail();
	$data['mails'][] = trim($new);
	f_save_gmail($data['mails'], $data); 
	f_gmail();
	}
//
function f_save_gmail($mails, $data=0)
	{
	global $key;
	$pgmail=0;
	if($data['pgmail'] && $key)
		{
		$iv = mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND);
		$pgmail = base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, substr($key,0,30), strip_tags($data['pgmail']), MCRYPT_MODE_ECB, $iv));
		}
	$xml = @new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><item></item>');
	$xml->addChild('mails', join("," ,$mails));
	$xml->addChild('subject', htmlspecialchars($data['subject']));
	$xml->addChild('body', htmlspecialchars($data['body']));    
	$xml->addChild('smtp', ($data['smtp']?$data['smtp']:'0'));
	$xml->addChild('gmail', ($data['gmail']?$data['gmail']:''));
	$xml->addChild('pgmail', ($pgmail?$pgmail:''));
	XMLsave($xml, CONFIGFILE);
	} 
//
function f_load_gmail()
	{
	global $key;
	$data = array(); $data['mails'] = null; $data['subject'] = ''; $data['body'] = ''; $data['smtp'] = '0'; $data['gmail'] = ''; $data['pgmail'] = ''; $pgmail='';
	if (file_exists(CONFIGFILE)) 
		{
		$xml = getXML(CONFIGFILE);
		if (!empty($xml))
			{
			if($xml->pgmail && $key)
				{
				$iv = mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND);
				$pgmail = mcrypt_decrypt(MCRYPT_RIJNDAEL_256, substr($key,0,30), strip_tags(base64_decode($xml->pgmail)), MCRYPT_MODE_ECB, $iv);
				}
			if ($xml->mails!="")	$data['mails'] = preg_split("[,]", $xml->mails);
			$data['subject'] = stripslashes($xml->subject);
			$data['body'] = stripslashes(utf8_decode($xml->body)); // mystere ici !!!
			$data['smtp'] = $xml->smtp;
			$data['gmail'] = $xml->gmail;
			$data['pgmail'] = (($xml->pgmail)?$pgmail:'');
			}
		}
	else
		{
		$xml = @new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><item></item>');
		XMLsave($xml, CONFIGFILE);
		}
	return $data; 
	}
//
function f_gmail_form($text='Ajouter')
	{
	echo '<form style="display:inline;margin-left:100px;" action="load.php?id=gmail_newsletter&add" method="post" accept-charset="utf-8">';
	echo '<input name="new-mail" type="text" value="" size="40">';
	echo '<input style="margin:0 10px;padding:2px 8px;line-height:14px;" name="submit" type="submit" class="submit" value="'.$text.'" />';
	echo '</form>';
	echo '<div style="font-style:italic;margin:10px">* Pour plusieurs mails en une fois : s&eacute;paration par une <strong>virgule sans espace</strong> : sam@free.fr,tom@free.fr</div>';
	echo '<div style="margin:10px">Pour avoir un formulaire d\'inscription, ajouter ce code au contenu de votre page : <strong>(% gmail_newsletter %)</strong></div>';
	}
function f_shortcode($contents)
	{
	// shortcode : (% gmail_newsletter %)
	$admail = "";
	$scan = scandir('data/users/');
	foreach ($scan as $s)
		{
		if (preg_match("#\.xml$#", $s))
			{
			$data = getXML(GSUSERSPATH . $s);
			$admail = $data->EMAIL;
			break;
			}
		}
	$pat = '`(?<!<code>)\(%\s*gmail_newsletter\s*%\)`';
	$out = '<form class="gmail_newsletterFrm" method="POST" action="plugins/gmail_newsletter/add.php">'."\r\n".
		'<input type="hidden" name="action" value="new" />'."\r\n".
		'<input type="hidden" name="back" value="'.get_site_url(false).'" />'."\r\n".
		'<input type="hidden" name="am" value="'.base64_encode($admail).'" />'."\r\n".
		'<label>Adresse email : </label>'."\r\n".
		'<input type="text" name="mail" value="" />'."\r\n".
		'<input style="margin-left:10px;" type="submit" value="Inscription*" />'."\r\n".
		'</form><div style="font-size:90%">* Vous recevrez un mail avec un lien de confirmation.</div>';"\r\n".
	$contents = preg_replace($pat,$out,$contents, 1);
	return $contents;
	}
//
?>